# SecureUML-GUI
A ArgoUML extensions for modelling SecureUML supporting various SecureUML
dialects with and without support for Generic Break Glass concepts. 

## Installation
1. Download ArgoUML 0.26.2 from [http://argouml-downloads.tigris.org/argouml-0.26.2/](http://argouml-downloads.tigris.org/argouml-0.26.2/)
2. Unzip the ArgoUML 0.26.2 archive 
3. Rename `local.properties.in` to `local.properties` and edit the file so that 
   `argo.home.dir` points to the directory that was created by unzipping the 
   ArgoUML 0.26.2 archive
4. Build and install the SecureUML plugin: `ant install`
 
## License
This project is licensed under a 2-clause BSD license. 

## Team 
* [Achim D. Brucker](http://www.brucker.ch/)
* Jürgen Doser
* [Helmut Petritsch](http://petritsch.co.at/)

### Contributors
* Marcel Beer
* Andreas Schmidt

## Publications
* Achim D. Brucker and Helmut Petritsch. [Extending access control 
  models with break-glass.](https://www.brucker.ch/bibliography/download/2009/brucker.ea-extending-2009.pdf) 
  In Proceedings of the 14th ACM symposium on Access control models 
  and technologies (SACMAT '09). ACM, New York, NY, USA, 197-206. 2009. 
  https://www.brucker.ch/bibliography/abstract/brucker.ea-extending-2009
  doi: [10.1145/1542207.1542239](http://dx.doi.org/10.1145/1542207.1542239)
* Achim D. Brucker and Jürgen Doser. [Metamodel-based UML Notations for 
  Domain-specific Languages.](https://www.brucker.ch/bibliography/download/2007/brucker.ea-metamodel-2007.pdf) 
  In 4th International Workshop on Software Language Engineering (ATEM 2007), 
  2007.
  https://www.brucker.ch/bibliography/abstract/brucker.ea-metamodel-2007
* Achim D. Brucker, Jürgen Doser, and Burkhart Wolff. [A Model
  Transformation Semantics and Analysis Methodology for SecureUML.](https://www.brucker.ch/bibliography/download/2006/brucker.ea-transformation-2006.pdf) In
  MoDELS 2006: Model Driven Engineering Languages and Systems. Lecture
  Notes in Computer Science (4199), pages 306-320,
  Springer-Verlag, 2006.
  https://www.brucker.ch/bibliography/abstract/brucker.ea-transformation-2006
  doi: [10.1007/11880240_22](http://dx.doi.org/10.1007/11880240_22) 
